﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using ControllerDllCSharp;
using static ControllerDllCSharp.ClassLibControllerDll;
using System.Runtime.InteropServices;

namespace ControllerDemo
{
    #if _WIN32
            using ControllerHandle = Int32;
    #else
        using ControllerHandle = Int64;
    #endif
    public partial class Form1 : Form
    {
        private ControllerHandle controllerHandle = 0;
        public Form1()
        {
            InitializeComponent();
        }
        private void button6_Click(object sender, EventArgs e) //遍历网卡
        {
            comboBox1.Items.Clear();
            comboBox2.Items.Clear();
            int AdapterNum = 0;

            int workStationCount = 10;
            int size = Marshal.SizeOf(typeof(Adapter_prm));
            IntPtr mAdapterPrmPtr = Marshal.AllocHGlobal(size * workStationCount);
            Adapter_prm[] mAdapter_prm = new Adapter_prm[workStationCount];
            if (GetAdapter(ref AdapterNum, mAdapterPrmPtr) == SUCCESS)
            {
                for (int inkIndex = 0; inkIndex < workStationCount; inkIndex++)
                {
                    IntPtr ptr = (IntPtr)(mAdapterPrmPtr + inkIndex * size);
                    mAdapter_prm[inkIndex] = (Adapter_prm)Marshal.PtrToStructure(ptr, typeof(Adapter_prm));
                }

                string[] SnBuffer = new string[AdapterNum];
                for (int i = 0; i < AdapterNum; i++)
                {
                    SnBuffer[i] = new string(mAdapter_prm[i].cSn);
                    comboBox1.Items.Add(SnBuffer[i]);
                }
                string[] IpBuffer = new string[AdapterNum];
                for (int i = 0; i < AdapterNum; i++)
                {
                    IpBuffer[i] = new string(mAdapter_prm[i].cIp);
                    comboBox2.Items.Add(IpBuffer[i]);
                }
                comboBox2.Text = IpBuffer[0];
                textBoxMessageShow.Text = "成功获取网卡信息";
            }
            else
            {
                textBoxMessageShow.Text = "获取网卡信息失败";
            }
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            int id1 = comboBox1.SelectedIndex;
            comboBox2.SelectedIndex = id1;
        }

        private void comboBox2_SelectedIndexChanged(object sender, EventArgs e)
        {
            int id2 = comboBox2.SelectedIndex;
            comboBox1.SelectedIndex = id2;
        }

        static int workStationCount = 50; 
        Host_prm[] mHost_prm = new Host_prm[workStationCount];  
        private void buttonGetHost_Click(object sender, EventArgs e) //搜索控制器
        {
            int controllerCnt = 0;
            comboBoxSn.Items.Clear();
            textBoxIpAddress.Text = "";
            textBoxSm.Text = "";
            textBoxGw.Text = "";
            textBoxSn.Text = "";

            string AdapterIP = comboBox2.Text;
            int size = Marshal.SizeOf(typeof(Host_prm));
            IntPtr mHostPrmPtr = Marshal.AllocHGlobal(size * workStationCount);
            if (GetHost(ref controllerCnt, mHostPrmPtr, AdapterIP) == SUCCESS) //获取设备
            {
                for (int inkIndex = 0; inkIndex < workStationCount; inkIndex++)
                {
                    IntPtr ptr = (IntPtr)(mHostPrmPtr + inkIndex * size);
                    mHost_prm[inkIndex] = (Host_prm)Marshal.PtrToStructure(ptr, typeof(Host_prm));
                }

                if (controllerCnt > 0)
                {
                    string[] SnBuffer = new string[controllerCnt];
                    for (int i = 0; i < controllerCnt; i++)
                    {
                        SnBuffer[i] = new string(mHost_prm[i].cSn);
                        comboBoxSn.Items.Add(SnBuffer[i]);
                        comboBoxSn.Text = SnBuffer[0];
                        textBoxSn.Text = comboBoxSn.Text;
                    }

                    string[] IpBuffer = new string[controllerCnt];
                    for (int i = 0; i < controllerCnt; i++)
                    {
                        IpBuffer[i] = new string(mHost_prm[i].cIp);
                        textBoxIpAddress.Text = IpBuffer[0];
                    }

                    buttonSetHost.Enabled = true;
                    textBoxMessageShow.Text = $"成功获取控制器信息，该网卡下控制器数量为：{controllerCnt}";
                }
                else
                {
                    buttonSetHost.Enabled = false;
                    textBoxMessageShow.Text = $"该网卡下控制器数量为：{controllerCnt}";
                }
            }
            else
            {
                textBoxMessageShow.Text = "获取控制器信息失败";
            }

            int size1 = Marshal.SizeOf(typeof(Controller_prm));
            IntPtr mConPrmPtr = Marshal.AllocHGlobal(size1);
            Controller_prm mConPrm;
            if (GetConfigure(mHost_prm[0].cMac, mConPrmPtr, AdapterIP) == SUCCESS) //获取参数
            {
                IntPtr ptr = (IntPtr)(mConPrmPtr);
                mConPrm = (Controller_prm)Marshal.PtrToStructure(ptr, typeof(Controller_prm));

                string SmBuffer;
                SmBuffer = new string(mConPrm.cSm);
                textBoxSm.Text = SmBuffer;

                string GwBuffer;
                GwBuffer = new string(mConPrm.cGw);
                textBoxGw.Text = GwBuffer;

                string IpBuffer;
                IpBuffer = new string(mConPrm.cIp);
                textBoxIpAddress.Text = IpBuffer;

                if (mConPrm.DHCP == 0)
                {
                    checkBox_DHCP.Checked = false;
                }
                else
                {
                    checkBox_DHCP.Checked = true;
                }
            }
        }

        private void comboBoxSn_SelectedIndexChanged(object sender, EventArgs e) //切换控制器
        {
            string AdapterIP = comboBox2.Text;
            int size1 = Marshal.SizeOf(typeof(Controller_prm));
            IntPtr mConPrmPtr = Marshal.AllocHGlobal(size1);
            Controller_prm mControllerPrm;
            if (GetConfigure(mHost_prm[comboBoxSn.SelectedIndex].cMac, mConPrmPtr, AdapterIP) == SUCCESS) //获取当前参数
            {
                IntPtr ptr = (IntPtr)(mConPrmPtr);
                mControllerPrm = (Controller_prm)Marshal.PtrToStructure(ptr, typeof(Controller_prm));

                textBoxSn.Text = comboBoxSn.Text;

                string SmBuffer;
                SmBuffer = new string(mControllerPrm.cSm);
                textBoxSm.Text = SmBuffer;

                string GwBuffer;
                GwBuffer = new string(mControllerPrm.cGw);
                textBoxGw.Text = GwBuffer;

                string IpBuffer;
                IpBuffer = new string(mControllerPrm.cIp);
                textBoxIpAddress.Text = IpBuffer;

                if (mControllerPrm.DHCP == 0)
                {
                    checkBox_DHCP.Checked = false;
                }
                else
                {
                    checkBox_DHCP.Checked = true;
                }
            }
        }

        private void checkBox_DHCP_CheckedChanged(object sender, EventArgs e) //DHCP
        {
            if (checkBox_DHCP.Checked == true)
            {
                textBoxSn.Enabled = false;
                textBoxIpAddress.Enabled = false;
                textBoxSm.Enabled = false;
                textBoxGw.Enabled = false;
            }
            else
            {
                textBoxSn.Enabled = true;
                textBoxIpAddress.Enabled = true;
                textBoxSm.Enabled = true;
                textBoxGw.Enabled = true;
            }
        }

        private void buttonSetHost_Click(object sender, EventArgs e) //配置控制器网络信息
        {
            string mStr;
            Controller_prm mControllerInf = new Controller_prm();
            mStr = "000000000000000000000";
            mControllerInf.cSn = mStr.ToCharArray();
            mStr = "0000000000000000";
            mControllerInf.cIp = mStr.ToCharArray();
            mControllerInf.cGw = mStr.ToCharArray();
            mControllerInf.cSm = mStr.ToCharArray();
            for (uint i = 0; i < 21; i++)
            {
                mControllerInf.cSn[i] = '\0';
            }
            for (uint i = 0; i < 16; i++)
            {
                mControllerInf.cIp[i] = '\0';
            }
            for (uint i = 0; i < 16; i++)
            {
                mControllerInf.cGw[i] = '\0';
            }
            for (uint i = 0; i < 16; i++)
            {
                mControllerInf.cSm[i] = '\0';
            }
            textBoxIpAddress.Text.ToCharArray().CopyTo(mControllerInf.cIp, 0);
            textBoxGw.Text.ToCharArray().CopyTo(mControllerInf.cGw, 0);
            textBoxSm.Text.ToCharArray().CopyTo(mControllerInf.cSm, 0);
            textBoxSn.Text.ToCharArray().CopyTo(mControllerInf.cSn, 0);

            if (checkBox_DHCP.Checked == true)
            {
                mControllerInf.DHCP = (char)1;
            }
            else
            {
                mControllerInf.DHCP = (char)0;
            }

            string adapterIp = comboBox2.Text;

            if (SetConfigure(mHost_prm[comboBoxSn.SelectedIndex].cMac, ref mControllerInf, adapterIp) == SUCCESS)
            {
                textBoxMessageShow.Text = ("成功设置控制器信息");
            }
            else
            {
                textBoxMessageShow.Text = ("设置IP失败,请检查地址的合法性");
            }
        }

        int connectTimeOut  = 1; //单位S
        private void button1_Click(object sender, EventArgs e) //IP连接
        {
            if (button1.Text == "IP连接ConnectIP/DestroyIpConnection")
            {
                string IP = textBoxIpAddress.Text.ToString(); //获取取IP
                int RT1 = ConnectIP(IP, connectTimeOut, ref controllerHandle); //IP连接
                if (RT1 == SUCCESS)
                {
                    button1.Text = "断开连接";
                    textBoxMessageShow.Text = "IP连接控制器成功";
                }
                else
                {
                    textBoxMessageShow.Text = "IP连接控制器失败";
                }
            }
            else if (button1.Text == "断开连接")
            {
                int RT1 = DestroyIpConnection(controllerHandle); //断开IP连接
                if (RT1 == SUCCESS)
                {
                    button1.Text = "IP连接ConnectIP/DestroyIpConnection";
                    textBoxMessageShow.Text = "IP断开控制器成功";
                }
                else
                {
                    textBoxMessageShow.Text = "IP断开控制器失败";
                }
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (button2.Text == "打开串口CreateSerialPort/ReleaseSerialPort")
            {
                int ComNum = Convert.ToInt32(textBox2.Text); //获取串口号
                int RT3 = CreateSerialPort(ComNum, ref controllerHandle);  //创建串口
                if (RT3 == SUCCESS)
                {
                    button2.Text = "断开串口";
                    textBoxMessageShow.Text = "成功打开串口";
                }
                else
                {
                    textBoxMessageShow.Text = "打开串口失败";
                }
            }
            else if (button2.Text == "断开串口")
            {
                int RT3 = ReleaseSerialPort(controllerHandle);  //断开串口
                if (RT3 == SUCCESS)
                {
                    button2.Text = "打开串口CreateSerialPort/ReleaseSerialPort";
                    textBoxMessageShow.Text = "成功释放串口";
                }
                else
                {
                    textBoxMessageShow.Text = "释放串口失败";
                }
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            int value = 0;
            int channelIndex = 1;
            if (GetDigitalValue(ref value, channelIndex, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功获取{channelIndex}通道亮度值为：{value}";
            }
            else
            {
                textBoxMessageShow.Text = $"获取{channelIndex}通道亮度值失败";
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            int value = 100;
            int channelIndex = 1;
            if (SetDigitalValue(channelIndex, value, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功设置{channelIndex}通道亮度值为：{value}";
            }
            else
            {
                textBoxMessageShow.Text = $"设置{channelIndex}通道亮度值失败";
            }
        }

        private void button7_Click(object sender, EventArgs e)
        {
            int value = 0;
            int channelIndex = 1;
            if (GetStrobeValue(ref value, channelIndex, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功获取{channelIndex}通道脉宽值为：{value}";
            }
            else
            {
                textBoxMessageShow.Text = $"获取{channelIndex}通道脉宽值失败";
            }
        }

        private void button5_Click(object sender, EventArgs e)
        {
            int value = 100;
            int channelIndex = 1;
            if (SetStrobeValue(channelIndex, value, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功设置{channelIndex}通道脉宽值为：{value}";
            }
            else
            {
                textBoxMessageShow.Text = $"设置{channelIndex}通道脉宽值失败";
            }
        }

        private void button8_Click(object sender, EventArgs e)
        {
            int value = 0;
            int channelIndex = 1;
            if (GetLightDelayValue(ref value, channelIndex, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功获取{channelIndex}通道光源延时输出值为：{value}";
            }
            else
            {
                textBoxMessageShow.Text = $"获取{channelIndex}通道光源延时输出值失败";
            }
        }

        private void button9_Click(object sender, EventArgs e)
        {
            int value = 100;
            int channelIndex = 1;
            if (SetLightDelayValue(channelIndex, value, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功设置{channelIndex}通道光源延时输出值为：{value}";
            }
            else
            {
                textBoxMessageShow.Text = $"设置{channelIndex}通道光源延时输出值失败";
            }
        }

        private void button10_Click(object sender, EventArgs e)
        {
            int value = 0;
            int channelIndex = 1;
            if (GetCameraDelayValue(ref value, channelIndex, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功获取{channelIndex}通道相机延时输出值为：{value}";
            }
            else
            {
                textBoxMessageShow.Text = $"获取{channelIndex}通道相机延时输出值失败";
            }
        }

        private void button11_Click(object sender, EventArgs e)
        {
            int value = 100;
            int channelIndex = 1;
            if (SetCameraDelayValue(channelIndex, value, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功设置{channelIndex}通道相机延时输出值为：{value}";
            }
            else
            {
                textBoxMessageShow.Text = $"设置{channelIndex}通道相机延时输出值失败";
            }
        }

        private void button12_Click(object sender, EventArgs e)
        {
            int value = 0;
            if (GetIntCycleValue(ref value, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功获取内触发周期值为：{value}";
            }
            else
            {
                textBoxMessageShow.Text = $"获取内触发周期值失败";
            }
        }

        private void button13_Click(object sender, EventArgs e)
        {
            int value = 100;
            if (SetIntCycleValue(value, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功设置内触发周期值为：{value}";
            }
            else
            {
                textBoxMessageShow.Text = $"设置内触发周期值失败";
            }
        }

        private void button14_Click(object sender, EventArgs e)
        {
            int value = 0;
            if (GetLightTriMode(ref value, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功获取内/外触发模式值为：{value}";
            }
            else
            {
                textBoxMessageShow.Text = $"获取内/外触发模式值失败";
            }
        }

        private void button15_Click(object sender, EventArgs e)
        {
            int value = 1;
            if (SetLightTriMode(value, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功设置内/外触发模式值为：{value}";
            }
            else
            {
                textBoxMessageShow.Text = $"设置内/外触发模式值失败";
            }
        }

        private void button16_Click(object sender, EventArgs e)
        {
            int value = 0;
            if (GetCamTriEdge(ref value, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功获取相机触发模式值为：{value}";
            }
            else
            {
                textBoxMessageShow.Text = $"获取相机触发模式值失败";
            }
        }

        private void button17_Click(object sender, EventArgs e)
        {
            int value = 1;
            if (SetCamTriEdge(value, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功设置相机触发模式值为：{value}";
            }
            else
            {
                textBoxMessageShow.Text = $"设置相机触发模式值失败";
            }
        }

        private void button19_Click(object sender, EventArgs e)
        {
            int value = 0;
            if (GetLightState(ref value, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功获取常亮/长灭模式值为：{value}";
            }
            else
            {
                textBoxMessageShow.Text = $"获取常亮/长灭模式值失败";
            }
        }

        private void button18_Click(object sender, EventArgs e)
        {
            int value = 1;
            if (SetLightState(value, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功设置常亮/长灭模式值为：{value}";
            }
            else
            {
                textBoxMessageShow.Text = $"设置常亮/长灭模式值失败";
            }
        }

        private void button23_Click(object sender, EventArgs e)
        {
            if (KeepAlive(controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功发送心跳";
            }
            else
            {
                textBoxMessageShow.Text = $"发送心跳失败";
            }
        }

        private void button43_Click(object sender, EventArgs e)
        {
            byte[] value = new byte[20];
            if (GetErrMsg(Convert.ToInt32(textBox1.Text), value) == SUCCESS)
            {
                textBoxMessageShow.Text = "成功获取error代码定义值为：" + System.Text.Encoding.Default.GetString(value);
            }
            else
            {
                textBoxMessageShow.Text = $"获取获取error代码定义失败";
            }
        }

        private void button22_Click(object sender, EventArgs e)
        {
            int triggerSourceIndex = 1;
            int stepIndex = 1;
            ProgramConfiguration[] ProgramConfigurationArray = new ProgramConfiguration[2];
            ProgramConfigurationArray[0].channelIndex = 1;
            ProgramConfigurationArray[0].intensity = 50;
            ProgramConfigurationArray[0].pulseWidth = 100;
            ProgramConfigurationArray[1].channelIndex = 3;
            ProgramConfigurationArray[1].intensity = 20;
            ProgramConfigurationArray[1].pulseWidth = 40;
            if (SetProgramParameter(triggerSourceIndex, stepIndex, ProgramConfigurationArray.Length, ProgramConfigurationArray, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功设置可编程参数";
            }
            else
            {
                textBoxMessageShow.Text = $"设置可编程参数失败";
            }
        }

        private void button21_Click(object sender, EventArgs e)
        {
            int triggerSourceIndex = 1;
            int stepIndex = 1;
            int Length = 0;
            ProgramConfiguration[] ProgramConfigurationArray = new ProgramConfiguration[8];
            if (GetProgramParameter(triggerSourceIndex, stepIndex,ref Length, ProgramConfigurationArray, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功获取可编程参数";
            }
            else
            {
                textBoxMessageShow.Text = $"获取可编程参数失败";
            }
        }

        private void button20_Click(object sender, EventArgs e)
        {
            int value = 1;
            if (ClearProgramParameter(value, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功清空触发源{value}的可编程参数";
            }
            else
            {
                textBoxMessageShow.Text = $"清空触发源{value}的可编程参数失败";
            }
        }

        private void button31_Click(object sender, EventArgs e)
        {
            int value = 0;
            int channelIndex = 1;
            if (GetPulseUnit(channelIndex, ref value, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功获取通道{channelIndex}的脉宽单位值为：{value}";
            }
            else
            {
                textBoxMessageShow.Text = $"获取通道{channelIndex}的脉宽单位值失败";
            }
        }

        private void button30_Click(object sender, EventArgs e)
        {
            int value = 1;
            int channelIndex = 1;
            if (SetPulseUnit(channelIndex, value, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功设置通道{channelIndex}的脉宽单位值为：{value}";
            }
            else
            {
                textBoxMessageShow.Text = $"设置通道{channelIndex}的脉宽单位值失败";
            }
        }

        private void button29_Click(object sender, EventArgs e)
        {
            int value = 0;
            if (GetLightTriPty(ref value, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功获取触发极性值为：{value}";
            }
            else
            {
                textBoxMessageShow.Text = $"获取触发极性值为：{value}失败";
            }
        }

        private void button28_Click(object sender, EventArgs e)
        {
            int value = 0;
            if (SetLightTriPty(value, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功设置触发极性值为：{value}";
            }
            else
            {
                textBoxMessageShow.Text = $"设置触发极性值为：{value}失败";
            }
        }

        private void button27_Click(object sender, EventArgs e)
        {
            int value = 1;
            int triggerSourceIndex = 1;
            if (SetCurrentStep(triggerSourceIndex, value, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功设置应用场景{triggerSourceIndex}的当前触发步骤数为：{value}";
            }
            else
            {
                textBoxMessageShow.Text = $"设置应用场景{triggerSourceIndex}的当前触发步骤数失败";
            }
        }

        private void button26_Click(object sender, EventArgs e)
        {
            int value = 0;
            int triggerSourceIndex = 1;
            if (GetCurrentStep(triggerSourceIndex, ref value, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功获取应用场景{triggerSourceIndex}的当前触发步骤数为：{value}";
            }
            else
            {
                textBoxMessageShow.Text = $"获取应用场景{triggerSourceIndex}的当前触发步骤数失败";
            }
        }

        private void button25_Click(object sender, EventArgs e)
        {
            int triggerSourceIndex = 1;
            if (ResetCurrentStep(triggerSourceIndex, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功复位应用场景{triggerSourceIndex}的触发步骤数";
            }
            else
            {
                textBoxMessageShow.Text = $"复位应用场景{triggerSourceIndex}的触发步骤数失败";
            }
        }

        private void button24_Click(object sender, EventArgs e)
        {
            int value = 0;
            int triggerSourceIndex = 1;
            if (GetTotalStep(triggerSourceIndex, ref value, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功获取应用场景{triggerSourceIndex}的总触发步骤数为：{value}";
            }
            else
            {
                textBoxMessageShow.Text = $"获取应用场景{triggerSourceIndex}的总触发步骤数失败";
            }
        }

        private void button32_Click(object sender, EventArgs e)
        {
            int value = 100;
            int channelIndex = 1;
            if (SetDigitalValue_s(channelIndex, value, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功设置{channelIndex}通道亮度值为：{value}";
            }
            else
            {
                textBoxMessageShow.Text = $"设置{channelIndex}通道亮度值失败";
            }
        }

        private void button33_Click(object sender, EventArgs e)
        {
            MulDigitalValue_s[] MulDigValArray = new MulDigitalValue_s[2];
            MulDigValArray[0].channelIndex = 1;
            MulDigValArray[0].DigitalValue = 100;
            MulDigValArray[1].channelIndex = 2;
            MulDigValArray[1].DigitalValue = 200;
            if (SetMulDigitalValue_s(MulDigValArray, MulDigValArray.Length, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功设置多通道亮度值";
            }
            else
            {
                textBoxMessageShow.Text = $"设置多通道亮度值失败";
            }
        }

        private void button34_Click(object sender, EventArgs e)
        {
            int value = 0;
            int channelIndex = 1;
            if (GetDigitalValue_s(ref value, channelIndex, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功获取{channelIndex}通道亮度值为：{value}";
            }
            else
            {
                textBoxMessageShow.Text = $"获取{channelIndex}通道亮度值失败";
            }
        }

        private void button35_Click(object sender, EventArgs e)
        {
            int value = 1;
            int channelIndex = 1;
            if (SetON_OFF_s(channelIndex, value, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功设置通道{channelIndex}的ON/OFF值为：{value}";
            }
            else
            {
                textBoxMessageShow.Text = $"设置{channelIndex}通道ON/OFF值失败";
            }
        }

        private void button36_Click(object sender, EventArgs e)
        {
            MulONOFF_s[] MulONOFFArray = new MulONOFF_s[2];
            MulONOFFArray[0].channelIndex = 1;
            MulONOFFArray[0].onoffState = 0;
            MulONOFFArray[1].channelIndex = 2;
            MulONOFFArray[1].onoffState = 0;
            if (SetMulON_OFF_s(MulONOFFArray, MulONOFFArray.Length, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功设置多通道ON/OFF值";
            }
            else
            {
                textBoxMessageShow.Text = $"设置多通道ON/OFF值失败";
            }
        }

        private void button37_Click(object sender, EventArgs e)
        {
            int value = 0;
            int channelIndex = 1;
            if (GetON_OFF_s(channelIndex, ref value, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功获取{channelIndex}通道亮度值为：{value}";
            }
            else
            {
                textBoxMessageShow.Text = $"获取{channelIndex}通道亮度值失败";
            }
        }

        private void button38_Click(object sender, EventArgs e)
        {
            int value = 1;
            if (SetTriggerPolarity_s(value, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功设置触发极性值为：{value}";
            }
            else
            {
                textBoxMessageShow.Text = $"设置触发极性值失败";
            }
        }

        private void button39_Click(object sender, EventArgs e)
        {
            int value = 0;
            if (GetTriggerPolarity_s(ref value, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功获取触发极性值为：{value}";
            }
            else
            {
                textBoxMessageShow.Text = $"获取触发极性值失败";
            }
        }

        private void button40_Click(object sender, EventArgs e)
        {
            int value = 0;
            if (GetChannelNumberSummary_s(ref value, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功获取通道总数值为：{value}";
            }
            else
            {
                textBoxMessageShow.Text = $"获取通道总数失败";
            }
        }

        private void button41_Click(object sender, EventArgs e)
        {
            int value = 0;
            if (GetSoftwareVersion_s(ref value, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功获取固件版本值为：{value}";
            }
            else
            {
                textBoxMessageShow.Text = $"获取固件版本失败";
            }
        }

        private void button42_Click(object sender, EventArgs e)
        {
            byte[] value = new byte[20]; 
            if (GetControllerModel_s(value, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = "成功获取控制器型号值为：" + System.Text.Encoding.Default.GetString(value);
            }
            else
            {
                textBoxMessageShow.Text = $"获取控制器型号失败";
            }
        }

        private void button44_Click(object sender, EventArgs e)
        {
            int value = 100;
            int channelIndex = 1;
            if (SetColorTemperature_s(channelIndex, value, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功设置{channelIndex}通道色温值为：{value}";
            }
            else
            {
                textBoxMessageShow.Text = $"设置{channelIndex}通道色温值失败";
            }
        }

        private void button45_Click(object sender, EventArgs e)
        {
            MulColorTemperature_s[] MulColorTemperatureArray = new MulColorTemperature_s[2];
            MulColorTemperatureArray[0].channelIndex = 1;
            MulColorTemperatureArray[0].colorTemperature = 100;
            MulColorTemperatureArray[1].channelIndex = 2;
            MulColorTemperatureArray[1].colorTemperature = 200;
            if (SetMulColorTemperature_s(MulColorTemperatureArray, MulColorTemperatureArray.Length, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功设置多通道色温值";
            }
            else
            {
                textBoxMessageShow.Text = $"设置多通道色温值失败";
            }
        }

        private void button46_Click(object sender, EventArgs e)
        {
            int value = 0;
            int channelIndex = 1;
            if (GetColorTemperature_s(ref value, channelIndex, controllerHandle) == SUCCESS)
            {
                textBoxMessageShow.Text = $"成功获取{channelIndex}通道色温值为：{value}";
            }
            else
            {
                textBoxMessageShow.Text = $"获取{channelIndex}通道色温值失败";
            }
        }
    }
}
